VERSION 1.0 CLASS
BEGIN
   MultiUse = -1  'True
END
Attribute VB_Name = "PTSTTblInfoTbl"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Collection" ,"PTSTTblInfoTblItem"
Attribute VB_Ext_KEY = "Member0" ,"PTSTTblInfoTblItem"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'local variables
Private mCol As Collection
Private mTable As IVMtable
Private mEngine As PTSTEngine
Private bCollectionInitialised As Boolean
Private bTableInitialised As Boolean

Friend Property Set Table(ByVal vData As IVMtable)
   Set mTable = vData
   bCollectionInitialised = False
   bTableInitialised = True
End Property


Friend Property Get Table() As IVMtable
   If Not bTableInitialised Then InitTable
   Set Table = mTable
End Property


Friend Sub Clear()
   if Not mCol Is Nothing Then
      While mCol.Count > 0
         mCol.Remove(1)
      Wend
   End If
End Sub

Public Function Dump() As String
    Dump = mTable.Dump
End Function

Private Sub InitCollection()
   If Not bTableInitialised Then InitTable
   Set mCol = New Collection
   Dim RowIndex As Integer
   For RowIndex = 0 To mTable.CountOfRow - 1
      Dim objNewMember As PTSTTblInfoTblItem
      Set objNewMember = New PTSTTblInfoTblItem
      objNewMember.Key = Str(RowIndex)
      Set objNewMember.Parent = Me
      objNewMember.RowIndex = RowIndex
      mCol.Add objNewMember
   Set objNewMember = Nothing
   Next RowIndex
   bCollectionInitialised = False
End Sub


Public Function Add() As PTSTTblInfoTblItem
   If Not bTableInitialised Then InitTable
   'create a new object
   Dim objNewMember As PTSTTblInfoTblItem
   Set objNewMember = New PTSTTblInfoTblItem
   ' add row to the real table
   mTable.AddRow
   ' assign the parent and index to the new child
   Set objNewMember.Parent = Me
   objNewMember.RowIndex = mTable.CountOfRow - 1

   'return the object created
   Set Add = objNewMember
   Set objNewMember = Nothing
   bCollectionInitialised = False
End Function


Public Property Get Item(Index As Long) As PTSTTblInfoTblItem
   Attribute Item.VB_UserMemId = 0
   If Not bCollectionInitialised Then InitCollection
   If (Index <= 0) Or (Index > mCol.Count) Then
      Err.Raise -1, "PTSTTblInfoTblItem", "The table InfoTbl index " & Str(Index) & " was out of the range from 1 to " & Str(mCol.Count)
   End If
   Set Item = mCol(Index)
End Property


Public Property Get Count() As Long
   If Not bTableInitialised Then InitTable
   Count = mTable.CountOfRow
End Property


Public Sub Remove(vntIndexKey As Variant)
   Err.Raise (-1)
   ' Removing rows from the table is not supported
End Sub

Public Property Get NewEnum() As IUnknown
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
   'this property allows you to enumerate
   'this collection with the For...Each syntax
   If Not bCollectionInitialised Then InitCollection
   Set NewEnum = mCol.[_NewEnum]
End Property

Public Function HandleError()
   If Not mEngine Is Nothing Then
      mEngine.HandleError
   End If ' Else use default error handling
End Function

Public Property Get Engine() As PTSTEngine
   Set Engine = mEngine
End Property

Public Property Set Engine(vData As PTSTEngine)
   Set mEngine = vData
End Property

Private Sub Class_Initialize()
   'creates the collection when this class is created
   Set mCol = New Collection
   bCollectionInitialised = True
   bTableInitialised = False
End Sub


Private Sub InitTable()
   Set mTable = New VMtable
   ' Begin column data (comment used as an anchor for STVB6)
   mTable.AddColumn "SetIDPid", VMintegerType
   mTable.AddColumn "PatientNameFamilyNameSurnamerepeatsonlyfirstinstancemapped", VMstringType
   mTable.AddColumn "PatientNameGivenNamerepeatsonlyfirstinstancemapped", VMstringType
   mTable.AddColumn "DatetimeOfBirthTime", VMdatetimeType
   mTable.AddColumn "AdministrativeSex", VMstringType
   ' End column data (comment used as an anchor for STVB6)
   bTableInitialised = True
End Sub

Private Sub Class_Terminate()
   'destroys collection when this class is terminated
   Set mCol = Nothing
   Set mTable = Nothing
End Sub

